#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <functional>
#include <math.h>
#include "wx/wx.h"
#include "wx/grid.h"
#include "wx/textfile.h"
#include "wx/tokenzr.h"
#include "wx/filefn.h"
#include "datafit.h"
#include "xydatafile.h"


LSQResult fileDataFit(XYDataFile &file, std::vector <double> param0)
{
	LSQResult result = file.DataFit(param0);
	int nparams = param0.size();
	std::vector <double> param = result.GetParam();
	printf("RSS: %lf\n", result.sumsqr);
	for (int i = 0; i < nparams; i++) {
		printf("%f ", param[i]);
	}
	printf("\n");
	return result;
}

LSQResult autoDataFit(XYDataFile &file)
{
	LSQResult result = file.DataFit();
	std::vector <double> param = result.GetParam();
	int nparams = result.GetNumOfParams();
	printf("RSS: %lf\n", result.sumsqr);
	for (int i = 0; i < nparams; i++) {
		printf("%f ", param[i]);
	}
	printf("\n");
	return result;
}



int main()
{
	XYDataFile file;
	std::vector <double> param0;
	int nterms = 2;
	int nparams = nterms * 2;

	wxString fileName = wxString("Cs_gf.dat");
	//wxString fileName = wxString("Cs.dat");
	file.LoadFile(fileName);


	printf("LM data fit with auto fit\n");
	autoDataFit(file);
	return 0;
}

