#include <vector>
#include "datafit.h"

int main()
{
	LuaTerm *y = new LuaTerm("Examples/et_eppoly.lua");
	LuaTerm *x = static_cast<LuaTerm *>(y->Clone());
	delete y;
	
	std::vector <std::string> lsqparam_names = x->GetLSQParamNames();
	std::vector <std::string> fixparam_names = x->GetFixParamNames();
	std::vector <double> lsqparam = x->GetLSQParam();
	std::vector <double> fixparam = x->GetFixParam();

	printf("LSQ parameters\n");

	for (int i = 0; i < lsqparam_names.size(); i++) {
		printf("%s %lf\n", lsqparam_names[i].c_str(), lsqparam[i]);
	}

	printf("Fixed parameters\n");	
	for (int i = 0; i < fixparam_names.size(); i++) {
		printf("%s %lf\n", fixparam_names[i].c_str(), lsqparam[i]);
	}

	printf("Function values\n");	
	for (double T = 50; T <= 300; T+= 50) {
		printf("%10.2lf %10.3lf\n", T, x->CpFuncEval(T));
	}
	return 0;
}
